﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.Menu
@{
    ViewData["Title"] = "Index";
    //Layout = "~/Views/Shared/_Layout.cshtml";
}
@if (!string.IsNullOrEmpty(TempData["success"]?.ToString()))
{
    <script>
        toastr.success('@TempData["success"]');
    </script>
}
else if (!string.IsNullOrEmpty(TempData["error"]?.ToString()))
{
    <script>
        toastr.error('@TempData["error"]');
    </script>
}
<script src="~/Script/Master/Layout.js"></script>
<section>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Menu List</h1>
            <div class="titile_line"></div>
        </div>
         @if (ViewBag.message != null)
         {
             <script>toastr.success('@ViewBag.message')</script>
         }
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="service_line" id="dvForm">
                        <form asp-area="ApplicationManagement" asp-controller="Menu" asp-action="SubmitMenu" id="form" method="post"
                              data-ajax="true"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading..."
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/Menu/Index');"
                              data-ajax-failure="Errmsg(data);">
                            <input type="hidden" name="MenuId" id="MenuId" value="@Model.MenuId" />
                            <input type="hidden" name="EventType" id="EventType" value="@Model.EventType" />
                            <input type="hidden" name="SubMenuId" id="SubMenuId" value="@Model.SubMenuId" />
                            <div class="row">
                                <div class="col-12 text-center">
                                    <label>Select Menu Type</label>
                                    <div class="select_box m_bottom">
                                        <label class="radio-inline">
                                            <input type="radio" name="MenuType" id="Parent" value="1" onclick="HideParentChildMenu()" checked>Parent Menu
                                        </label>
                                        <label class="radio-inline">
                                            <input type="radio" name="MenuType" id="Child" value="2" onclick="ShowParentHideChildMenu()">Child Menu
                                        </label>
                                        <label class="radio-inline">
                                            <input type="radio" name="MenuType" id="Sub" value="3" onclick="ShowParentChildMenu()">SubMenu
                                        </label>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12" id="ParentMenu">
                                    <label>Parent Menu</label>
                                    <div class="select_box m_bottom">
                                        <select class="form-control m_no" name="ParentMenuId" id="ParentMenuId" onchange="GetChildMenu(this,0)" required>
                                            <option value="">Select Parent Menu</option>
                                            @foreach (var item in Model.Menues.Where(x => x.ParentMenuId > 0 && x.ChildMenuId == 0 && x.SubMenuId == 0))
                                            {
                                                <option value="@item.ParentMenuId">@item.MenuName</option>
                                            }
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12" id="ChildMenu">
                                    <label>Child Menu</label>
                                    <div class="select_box m_bottom">
                                        <select class="form-control m_no" name="ChildMenuId" id="ChildMenuId" required>
                                            <option value="">Select Child Menu</option>
                                        </select>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Menu Name</label>
                                    <div class="select_box m_bottom">
                                        <input type="text" class="form-control m_no" name="MenuName" id="MenuName" value="@Model.MenuName" placeholder="Enter menu name" required>
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Menu Title</label>
                                    <div class="select_box m_bottom">
                                        <input type="text" class="form-control m_no" name="MenuTitle" id="MenuTitle" value="@Model.MenuTitle" placeholder="Enter menu title" required>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <div class="submitbtn">
                                        <input type="button" id="btnBack" name="Submit" value="Back" onclick="hideForm()">
                                    </div>
                                    <div class="submitbtn">
                                        <input type="submit" id="btnsubmit" name="Submit" value="Submit">
                                        <input type="reset" id="reset" value="reset" hidden />
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="assign_panel assign_section" id="dvDataTable">
                        <div class="addbtn">
                            <div class="add_litigation">
                                <span>+</span>
                                <input type="button" id="btnHideShow" onclick="showForm()" value="Add Menu">
                            </div>
                        </div><!--edn of addbtn-->
                        <div class="assign_box active_block fade in">
                            <div class="row">
                                <div class="table_control">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                            <tr>
                                                <th style="width: 70px;">SN</th>
                                                <th>Menu Type</th>
                                                <th>Menu Name</th>
                                                <th>Menu Title</th>
                                                <th style="width:130px">Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @{int sn = 0;}
                                            @foreach (var item in Model.Menues)
                                            {
                                                <tr>
                                                    <td>@(++sn)</td>
                                                    <td>@(item.MenuType==1? "Parent Menu" : item.MenuType==2? "Child Menu" : "Sub Menu")</td>
                                                    <td>@item.MenuName</td>
                                                    <td>@item.MenuTitle</td>
                                                    <td>
                                                        <a href="#" onclick="fnUpdate('@item.MenuId', '@item.ParentMenuId', '@item.ChildMenuId', '@item.SubMenuId', '@item.MenuName', '@item.MenuTitle', '@item.MenuType')" class="edit_btn"></a>
                                                        <a class="Active_btn" onclick="fn_Activeincative('@item.MenuId','@(item.IsActive?"deactivate":"activate")')"></a>
                                                        <a class="delete_btn" onclick="Confirmation('@item.MenuId')"></a>
                                                    </td>
                                                </tr>
                                            }
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>

<script>
    $(document).ready(function () {
        HideParentChildMenu();
    });
    function showForm() {
        $('#dvDataTable').hide();
        $('#dvForm').removeAttr('class');
        HideParentChildMenu();
    }
    function hideForm() {
        $('#reset').click();
        $('#dvDataTable').show();
        $('#dvForm').attr('class', 'service_line');
        HideParentChildMenu();
    }
    function HideParentChildMenu() {
        $('#ParentMenu').hide();
        $('#ParentMenuId').find('option').eq(0).attr('value', '0');
        $('#ParentMenuId').find('option').eq(0).attr('selected', 'selected');
        $('#ChildMenu').hide();
        $('#ChildMenuId').html('');
        $('#ChildMenuId').append('<option value="0" selected>Select Child Menu</option>');
    }
    function ShowParentHideChildMenu() {
        $('#ParentMenu').show();
        $('#ParentMenuId').find('option').eq(0).attr('value', '');
        $('#ParentMenuId').find('option').eq(0).attr('selected', 'selected');
        $('#ChildMenu').hide();
        $('#ChildMenuId').html('');
        $('#ChildMenuId').append('<option value="0" selected>Select Child Menu</option>');
    }
    function ShowParentChildMenu() {
        $('#ParentMenu').show();
        $('#ParentMenuId').find('option').eq(0).attr('value', '');
        $('#ParentMenuId').find('option').eq(0).attr('selected', 'selected');
        $('#ChildMenu').show();
        $('#ChildMenuId').html('');
        $('#ChildMenuId').append('<option value="" selected>Select Child Menu</option>');
    }
    function GetChildMenu(select, parentId) {
        $.get('/ApplicationManagement/Menu/GetChildMenuByParentId', { parentId: parentId > 0 ? parentId : parseInt($(select).val()) }, function (data) {
            debugger;
            $('#ChildMenuId').html('');
            if ($('#Sub').prop("checked")) {
                $('#ChildMenuId').append('<option value="" selected>Select Child Menu</option>');
            } else {
                $('#ChildMenuId').append('<option value="0" selected>Select Child Menu</option>');
            }
            $.each(data, function (i, value) {
                $('#ChildMenuId').append('<option value="' + value.childMenuId + '">' + value.menuName + '</option>');
            });
        });
    }
    function fnUpdate(MenuId, ParentMenuId, ChildMenuId, SubMenuId, MenuName, MenuTitle, MenuType) {
        showForm()
        switch (parseInt(MenuType)) {
            case 1: $('#Parent').trigger('click'); break;
            case 2: $('#Child').trigger('click'); break;
            case 3: $('#Sub').trigger('click'); break;
        }
        GetChildMenu(null, ParentMenuId);
        setTimeout(function () {
            $('#MenuId').val(MenuId);
            $('#ParentMenuId').val(ParentMenuId);
            $('#ChildMenuId').val(ChildMenuId);
            $('#SubMenuId').val(SubMenuId);
            $('#MenuName').val(MenuName);
            $('#MenuTitle').val(MenuTitle);
            $('#EventType').val(1);
        }, 1000);
    }
    function fnBlockDelete(MenuId, Action, Type) {
        if (confirm('Are you sure you want to ' + Action + ' this?')) {
            $.get('/ApplicationManagement/Menu/BlockDeleteMenu', { MenuId: MenuId, EventType: Type }, function (data) {
                if (data.code == 200) {
                    toastr.success(Action + ' successfully');
                    $('a[href="/ApplicationManagement/Menu/Index"]').click();
                } else {
                    toastr.error('Something went wrong!');
                }
            });
        }
    }
    function Confirmation(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to delete this menu',
            showCancelButton: true,
            confirmButtonText: 'Delete',
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/ApplicationManagement/Menu/BlockDeleteMenu",
                    type: "POST",
                    cache: false,
                    data: { menuId: id, Type: Type = 1 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success("Delete successfully!!");
                        $('a[href="/ApplicationManagement/Menu/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
    function fn_Activeincative(id, status) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to ' + status + ' this menu',
            showCancelButton: true,
            confirmButtonText: status,
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/ApplicationManagement/Menu/BlockDeleteMenu",
                    type: "POST",
                    cache: false,
                    data: { menuId: id, Type: Type = 0 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success(status + " " + "successfully!!");
                        $('a[href="/ApplicationManagement/Menu/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
</script>

